Subject: Re: [RFC PATCH 00/13] hardware time stamping + igb example implementation

From: Eric Dumazet <[email-masked]>
Date: Thu, 13 Nov 2008 07:29:25 +0100

Oliver Hartkopp a écrit :
> Andi Kleen wrote:
>> Eric Dumazet wrote:
>>
>>> I threw a "crazy idea", that can be changed if necessary, say with a 
>>> cookie
>>> that identifies the slot in NIC driver structure. O(1) lookup if 
>>> really needed.
>>
>> I think "crazy" describes it well because it would be a lot of dubious
>> and likely not performing well effort just to save 8 bytes.
> 
> Patrick,
> 
> one question about a new crazy idea:
> 
> If we would tend to add new space in the skb, won't 4 bytes enough then?
> 
> A 32 bit value gives a nsec resolution of 4.294967296 seconds or +/- 
> 2.147483648 seconds.
> 
> If we make a 'full qualified' 64 bit sys-timestamp available anyway, the 
> new 32 bit value could be used as an offest (or it could be given to the 
> userspace directly) to calculate the hw timestamp within the 
> sys-timestamp context, right?
> 

If NIC is going to receive 100.000 frames per second as Andi mentioned earlier
my guess is you dont want to make sophisticated computation in NIC rx handler,
but storing raw data delivered by NIC.

Then, later, for the happy few^Wmany applications that need to get hwstamp, perform
the computation if needed ?

I hope tcp stack wont need hwstamp before 2013 or so ;)